

# dessine c=((i,j),(rr,ss),(pc,mc,gc))
def dessine(c):
    rr=c[1][0]
    ss=c[1][1]
    d={'s':ss,'r':rr,'1':1}
    g=Graphics()
    y=0
    for i in range(3):
        x=0
        z=[ss,rr,1][i]
        for j in c[2][i]:
            g+=circle((x,y),z,fill=true,axes=false,figsize=16)
            seq=sequences(j).pop()
            a=0
            for k in range(len(seq)):
                zz=d.get(seq[k])
                g+=circle((x+(z+zz)*cos(a),y+(z+zz)*sin(a)),zz)
                a+=angle(d.get(seq[k]),z,d.get(seq[mod(k+1,len(seq))]))
            x+=7
        y-=7
    return g

def dessine1(seq,tc,rr,ss,name):
    g=100
    f=open(name,'w')
    f.write('<svg>\n')
    d={'s':ss,'r':rr,'1':1}
    col={'s':'#888888','r':'#bbbbbb','1':'#eeeeee'}
    z=[ss,rr,1][tc]
    f.write('<circle cx="0" cy="0" r="%f" fill="%s" stroke="black" />\n'%(RR(g*z),col.get(['s','r','1'][tc])))
    a=0
    for k in range(len(seq)):
        zz=d.get(seq[k])
        f.write('<circle cx="%f" cy="%f" r="%f" fill="%s" stroke="black"/>\n'%(RR(g*(z+zz)*cos(a)),RR(g*(z+zz)*sin(a)),RR(g*zz),col.get(seq[k])))
        a+=angle(d.get(seq[k]),z,d.get(seq[mod(k+1,len(seq))]))
    f.write('</svg>\n')
    f.close()


# idem mais sortie svg
def dessine2(c,name):
    g=100
    f=open(name,'w')
    f.write('<svg width="%d" height="%d">\n'%((7*max([len(i) for i in c[2]])-1)*g,20*g))
    rr=c[1][0]
    ss=c[1][1]
    d={'s':ss,'r':rr,'1':1}
    col={'s':'#888888','r':'#bbbbbb','1':'#eeeeee'}
    y=3*g
# cercles rayons x+y pour faciliter dessin empilement à la main sous inkscape
    f.write('<circle cx="%d" cy="%d" r="%f" stroke="black" fill="red" opacity="0.5"/>\n'%(0,-5*g,RR(g*(1+1))))
    f.write('<circle cx="%d" cy="%d" r="%f" stroke="black" fill="red" opacity="0.5"/>\n'%(5*g,-5*g,RR(g*(1+rr))))
    f.write('<circle cx="%d" cy="%d" r="%f" stroke="black" fill="red" opacity="0.5"/>\n'%(10*g,-5*g,RR(g*(1+ss))))
    f.write('<circle cx="%d" cy="%d" r="%f" stroke="black" fill="red" opacity="0.5"/>\n'%(15*g,-5*g,RR(g*(rr+rr))))
    f.write('<circle cx="%d" cy="%d" r="%f" stroke="black" fill="red" opacity="0.5"/>\n'%(20*g,-5*g,RR(g*(rr+ss))))
    f.write('<circle cx="%d" cy="%d" r="%f" stroke="black" fill="red" opacity="0.5"/>\n'%(25*g,-5*g,RR(g*(ss+ss))))
    for i in range(3):
        x=3*g
        z=[ss,rr,1][i]
        for j in c[2][i]:
            f.write('<circle cx="%f" cy="%f" r="%f" fill="%s" stroke="black" />\n'%(x,y,RR(g*z),col.get(['s','r','1'][i])))
            seq=sequences(j).pop()
            a=0
            for k in range(len(seq)):
                zz=d.get(seq[k])
                f.write('<circle cx="%f" cy="%f" r="%f" fill="%s" stroke="black"/>\n'%(RR(x+g*(z+zz)*cos(a)),RR(y+g*(z+zz)*sin(a)),RR(g*zz),col.get(seq[k])))
                a+=angle(d.get(seq[k]),z,d.get(seq[mod(k+1,len(seq))]))
            x+=7*g
        y+=7*g
    f.write('</svg>\n')
    f.close()


# dessine toute une liste en svg dans un fichier
def dessine3(RS,name):
    g=100
    col={'s':'#888888','r':'#bbbbbb','1':'#eeeeee'}
    f=open(name,'w')
    f.write('<svg>\n')
    y=0
    for c in RS:
#        f.write('<text style="font-size:200" x="%d" y="%d" fill="black">(%d,%d)</text>\n'%(-10*g,y+50,c[0][0],c[0][1]))
        f.write('<text style="font-size:200" x="%d" y="%d" fill="black">%s</text>\n'%(-10*g,y+50,c[0][0]+'/'+c[0][1]))
        x=0
        d={'s':c[1][1],'r':c[1][0],'1':1}
        for i in range(3):
            z=[c[1][1],c[1][0],1][i]
            for j in c[2][i]:
                f.write('<g>\n')
                f.write(' <circle cx="%f" cy="%f" r="%f" fill="%s" stroke="black" />\n'%(x,y,RR(g*z),col.get(['s','r','1'][i])))
                seq=sequence(j) # on dessine la première séquence sans chercher les autres (overlap potentiel)
                a=0
                for k in range(len(seq)):
                    zz=d.get(seq[k])
                    f.write(' <circle cx="%f" cy="%f" r="%f" fill="%s" stroke="black"/>\n'%(RR(x+g*(z+zz)*cos(a)),RR(y+g*(z+zz)*sin(a)),RR(g*zz),col.get(seq[k])))
                    a+=angle(d.get(seq[k]),z,d.get(seq[mod(k+1,len(seq))]))
                f.write('</g>\n')
                x+=7*g
        y+=7*g
    f.write('</svg>\n')
    f.close()


################
# codage : liste des disques numérotés
# 2 premiers éléments : rayons des disques 0 et 1
# suivants : (x,y,r) ou (x,y,r,z) : disque rayon r collé aux disques N° x et y, éventuel doublon du N°z

# algo de Lagrange pour avoir une base réduite
def lagrange(u,v):
    if u.norm()<v.norm():
        (u,v)=(v,u)
    while u.norm()>v.norm():
        q=round(u*v/(v*v))
        r=u-q*v
        u=v
        v=r
    return (u,v)

def angle(x,y,z):
    return arccos(((y+x)^2+(y+z)^2-(x+z)^2)/2/(y+x)/(y+z))

def domaine(e,(rr,ss)):
    d={1:1,r:RR(rr),s:RR(ss)}
    pers=[]
    lc=[(0,0,e[0])]
    doublons=[]
    lc.append((d.get(e[0])+d.get(e[1]),0,e[1])) # les deux premiers disques
    for c in e[2:len(e)]: # ajoute un par un les disques suivants
        (xi,yi,ri)=lc[c[0]]
        (xj,yj,rj)=lc[c[1]]
        rk=c[2]
        a=arctan((yj-yi)/(xj-xi)) if xi<>xj else sign(yj-yi)*pi/2
        a+=pi if xj<xi else 0
        a+=angle(d.get(rj),d.get(ri),d.get(rk))
        xk=RR(xi+(d.get(ri)+d.get(rk))*cos(a))
        yk=RR(yi+(d.get(ri)+d.get(rk))*sin(a))
        if len(c)>3: # disque répété ?
            doublons.append(len(lc)) # retient que c'est un doublon
            per=(xk-lc[c[3]][0],yk-lc[c[3]][1]) # déduit une période
            if len(pers)==0 or (len(pers)==1 and abs(matrix([pers[0],per]).det())>1): # première période ou 2eme période indép ? (aire domaine fondamentale >1 car contient tjrs un grand disque d'aire pi)
                pers.append(per)
        lc.append((xk,yk,rk)) # ajoute le disque
    lc=[lc[i] for i in range(len(lc)) if i not in doublons] # vire les doublons
    pers=list(lagrange(vector(pers[0]),vector(pers[1]))) # base réduite
    # tourne le domaine pour amener le plus long vecteur de période à l'horizontale
    cosa=pers[1][0]/pers[1].norm()
    sina=-pers[1][1]/pers[1].norm()
    pers[0]=[cosa*pers[0][0]-sina*pers[0][1],sina*pers[0][0]+cosa*pers[0][1]]
    pers[1]=[cosa*pers[1][0]-sina*pers[1][1],sina*pers[1][0]+cosa*pers[1][1]]
    lc=[(cosa*c[0]-sina*c[1],sina*c[0]+cosa*c[1],c[2]) for c in lc]
    # symétrie axiale pour ramener plus court vecteur ds 1er quadrant
    if pers[0][0]<0:
        lc=[(-c[0],c[1],c[2]) for c in lc]
        pers[0][0]=-pers[0][0]
    if pers[0][1]<0:
        lc=[(c[0],-c[1],c[2]) for c in lc]
        pers[0][1]=-pers[0][1]
    print('densité : %f'%RR(sum([pi*d.get(c[2])^2 for c in lc])/abs(matrix(pers).det())))
    return (lc,pers)


# e=((pc,mc),empilement)
def dessine4(e):
    # calcule r et s à partir couronnes : pb : pas tjrs unicité, par ex 11ss/111rr
    print(e[0])
    (rr,ss)=pcmc2rs(angles(e[0][0]),angles(e[0][1]))
    (lc,pers)=domaine(e[1],(rr,ss))
    f=open('packing_'+e[0][0]+'_'+e[0][1]+'.svg','w')
    wh=(1000,900) # taille fenêtre de vue
    f.write('<svg xmlns:xlink="http://www.w3.org/1999/xlink" width="%d" height="%d">\n <defs>\n'%(wh[0],wh[1]))
    # facteur d'échelle
    g=sqrt(wh[0]*wh[1]/abs(det(matrix(pers)))/4) # le domaine fondamental occupe 1/4 du dessin
#    g=wh[0]/pers[1][0]/2 # base du domaine fondamental = moitié du dessin
    # décalage pour centrer le domaine fondamental
    x0=(wh[0]-g*pers[0][0]-g*pers[1][0])/2
    y0=(wh[1]-g*pers[0][1]-g*pers[1][1])/2
    # les disques (ds les defs)
#    version couleur
    f.write('  <g id="GD">\n   <circle cx="0" cy="0" r="%.3f" fill="#ffd42a" stroke="black"/>\n   <ellipse cx="0" cy="%d" rx="%.3f" ry="%.3f" fill="#ffffff" transform="rotate(-45)"/>\n  </g>\n'%(RR(g*1),RR(-g*7/10),RR(g/6),RR(g/10)))
    f.write('  <g id="MD">\n   <circle cx="0" cy="0" r="%.3f" fill="#5599ff" stroke="black"/>\n   <ellipse cx="0" cy="%d" rx="%.3f" ry="%.3f" fill="#ffffff" transform="rotate(-45)"/>\n  </g>\n'%(RR(g*rr),RR(-g*rr*7/10),RR(g*rr/6),RR(g*rr/10)))
    f.write('  <g id="PD">\n   <circle cx="0" cy="0" r="%.3f" fill="#e41010" stroke="black"/>\n   <ellipse cx="0" cy="%d" rx="%.3f" ry="%.3f" fill="#ffffff" transform="rotate(-45)"/>\n  </g>\n'%(RR(g*ss),RR(-g*ss*7/10),RR(g*ss/6),RR(g*ss/10)))
    # version niveaux gris
#    f.write('  <g id="GD"><circle cx="0" cy="0" r="%.3f" fill="#eeeeee" stroke="black"/>\n</g>\n'%RR(g*1))
#    f.write('  <g id="MD"><circle cx="0" cy="0" r="%.3f" fill="#bbbbbb" stroke="black"/>\n</g>\n'%RR(g*rr))
#    f.write('  <g id="PD"><circle cx="0" cy="0" r="%.3f" fill="#888888" stroke="black"/>\n</g>\n'%RR(g*ss))
    # version vide
#    f.write('  <g id="GD"><circle cx="0" cy="0" r="%.3f" fill="none" stroke="black"/>\n</g>\n'%RR(g*1))
#    f.write('  <g id="MD"><circle cx="0" cy="0" r="%.3f" fill="none" stroke="black"/>\n</g>\n'%RR(g*rr))
#    f.write('  <g id="PD"><circle cx="0" cy="0" r="%.3f" fill="none" stroke="black"/>\n</g>\n'%RR(g*ss))
    # le domaine fondamental (ds les defs)
    f.write('  <g id="DF">\n')
    disque={1:'GD',r:'MD',s:'PD'}
    for c in lc:
        f.write('   <use xlink:href="#%s" x="%.3f" y="%.3f"/>\n'%(disque.get(c[2]),g*c[0],g*c[1]))
    f.write('  </g>\n </defs>\n')
    # clone le domaine fondamental
#    kx=ceil((x0+g*pers[1][0])/(g*pers[0][0]+g*pers[1][0]))
#    ky=ceil(y0/(g*pers[0][1]+g*pers[1][1]))
#    for i in range(-kx-2,kx+3):
#        for j in range(-ky-2,ky+3):
    for i in range(-3,4):
        for j in range(-3,4):
            x=x0+g*(i*pers[0][0]+j*pers[1][0])
            y=y0+g*(i*pers[0][1]+j*pers[1][1])
            f.write(' <use xlink:href="#DF" x="%.3f" y="%.3f"/>\n'%(x,y))
    # dessine la base associée au domaine fondamental
    f.write(' <path d="M %.3f,%.3f %.3f,%.3f %.3f,%.3f %.3f,%.3f Z" style="stroke:#000000;fill:none;stroke-width:3"/>\n'%(x0,y0,x0+g*pers[0][0],y0+g*pers[0][1],x0+g*pers[0][0]+g*pers[1][0],y0+g*pers[0][1]+g*pers[1][1],x0+g*pers[1][0],y0+g*pers[1][1]))
    f.write('</svg>\n')
    f.close()


######################################

def repartition(e):
    print('calcul valeurs...')
    z=[pcmc2rs(angles(i[0][0]),angles(i[0][1])) for i in e] # 1 min
    print('approximations rationnelles...')
    z2=[(continued_fraction(i[0]).convergent(5),continued_fraction(i[1]/i[0]).convergent(5)) for i in z]
    print('diagramme de Voronoï...')
    v=VoronoiDiagram(z2)
    carre=Polyhedron([(0,0),(1,0),(1,1),(0,1)])  
    g=carre.plot(axes=false,aspect_ratio=1,fill=false,color='black',point=false)
    for d in v.regions().keys():
        w=v.regions().get(d).intersection(carre)
        g+=w.plot(point=false,fill=false,color='blue',thickness=0.1)
        g+=point(d.affine(),color='black')
        i=z2.index(d.affine())
        g+=text(i+1,w.center(),fontsize='x-small',color='black')
    return g+plot(1/r*(2/sqrt(3)-1),r,2/sqrt(3)-1,1,color='red')

# écriture tex
def blu(e):
    f=open('bla.tex','w')
    for i in range(55):
        f.write('\\noindent\n\\begin{tabular}{lll}\n')
        f.write('  %d\\hfill %s / %s & %d\\hfill %s / %s & %d\\hfill %s / %s\\\\\n'%(3*i+1,e[3*i][0][0],e[3*i][0][1],3*i+2,e[3*i+1][0][0],e[3*i+1][0][1],3*i+3,e[3*i+2][0][0],e[3*i+2][0][1]))
        f.write('  \\includegraphics[width=0.3\\textwidth]{%s_%s.pdf} &\n'%(e[3*i][0][0],e[3*i][0][1]))
        f.write('  \\includegraphics[width=0.3\\textwidth]{%s_%s.pdf} &\n'%(e[3*i+1][0][0],e[3*i+1][0][1]))
        f.write('  \\includegraphics[width=0.3\\textwidth]{%s_%s.pdf}\n'%(e[3*i+2][0][0],e[3*i+2][0][1]))
        f.write('\end{tabular}\n')
    f.close()



